﻿using System;
namespace myBlazorApp.Components;
using Blazorise;
using Microsoft.AspNetCore.Components;
using myBlazorApp.Models;

public partial class InventoryItem
{
    [Parameter]
    public Item? Item { get; set; }

    public string state { get; set; } = null;

    [Parameter]
    public int Index { get; set; }

    [Parameter]
    public bool NoDrop { get; set; }

    [CascadingParameter]
    public MyInventory Parent { get; set; }

    internal void OnDragEnter()
    {
        if (NoDrop)
        {
            return;
        }
        Parent.Actions.Add(new InventoryAction { Action = "Drag Enter", Item = this.Item, Index = this.Index });
        state = "enter";
        if (this.Item != null)
        {
            Thread.Sleep(2000);
            if (state == "enter")
            {
                Item item = Parent.CurrentDragItem;
                Parent.CurrentDragItem = this.Item;
                this.Item = item;
                Parent.Actions.Add(new InventoryAction { Action = "Drop", Item = item, Index = this.Index });
                Parent.Actions.Add(new InventoryAction { Action = "Drag Start", Item = Parent.CurrentDragItem, Index = this.Index });

            }
        }

    }

    internal void OnDragLeave()
    {
        if (NoDrop)
        {
            return;
        }
        Parent.Actions.Add(new InventoryAction { Action = "Drag Leave", Item = this.Item, Index = this.Index });
        state = "left";
    }

    internal void OnDrop()
    {
        if (NoDrop)
        {
            return;
        }
        if (this.Item == null)
        {
            this.Item = Parent.CurrentDragItem;
        }
        Parent.Actions.Add(new InventoryAction { Action = "Drop", Item = this.Item, Index = this.Index });
        state = null;
    }

    private void OnDragStart()
    {
        Parent.CurrentDragItem = this.Item;
        this.Item = null;
        Parent.Actions.Add(new InventoryAction { Action = "Drag Start", Item = this.Item, Index = this.Index });
        state = "start";
    }
}

